<template>
  <div>
    <div class="jeecg-basic-table-form-container" @keyup.enter="searchQuery">
      <a-form :model="queryParam" :label-col="labelCol" :wrapper-col="wrapperCol">
        <a-row :gutter="24">
          <a-col :lg="6">
            <a-form-item :label="searchFormSchema[0].label">
              <JInput placeholder="请输入" v-model:value="queryParam[searchFormSchema[0].field]" />
            </a-form-item>
          </a-col>
          
          <a-col :lg="6">
            <a-form-item :label="searchFormSchema[2].label">
              <JSelectDept placeholder="请输入" v-model:value="jSelectDeptVal" :multiple="false" @change="updateJSelectDept" />
            </a-form-item>
          </a-col>
          <a-col :lg="6">
            <a-form-item>
              <a-space :size="5">
                <a-button type="primary" preIcon="ant-design:search-outlined" @click="searchQuery">查询</a-button>
                <a-button type="primary" preIcon="ant-design:reload-outlined" @click="searchReset">重置</a-button>
              </a-space>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>

      <!--引用表格-->
      <BasicTable @register="registerTable" :rowSelection="rowSelection">
        <!--插槽:table标题-->
        <template #tableTitle>
        <!--
          <a-button type="primary" @click="handleAdd" preIcon="ant-design:plus-outlined"> 新建</a-button>
         -->
          <a-button v-show="showUpBtn" type="primary" preIcon="ant-design:export-outlined" @click="onExportXls"> 导出</a-button>
          <j-upload-button v-show="showUpBtn" type="primary" preIcon="ant-design:import-outlined" @click="onImportXls">导入</j-upload-button>
          <a-dropdown v-if="selectedRowKeys.length > 0 && showUpBtn">
            <template #overlay>
              <a-menu>
                <a-menu-item key="1" @click="batchHandleDelete">
                  <Icon icon="ant-design:delete-outlined" />
                  删除
                </a-menu-item>
              </a-menu>
            </template>
            <a-button
              >批量操作
              <Icon icon="mdi:chevron-down" />
            </a-button>
          </a-dropdown>
        </template>
        <!--操作栏-->
        <template #action="{ record }">
          <TableAction :actions="getTableAction(record)" :dropDownActions="getDropDownAction(record)" />
        </template>
        <!--字段回显插槽-->
        <template #htmlSlot="{ text }">
          <div v-html="text"></div>
        </template>
        <!--省市区字段回显插槽-->
        <template #pcaSlot="{ text }">
          {{ getAreaTextByCode(text) }}
        </template>
        <template #fileSlot="{ text }">
          <span v-if="!text" style="font-size: 12px; font-style: italic">无文件</span>
          <a-button v-else :ghost="true" type="primary" preIcon="ant-design:download-outlined" size="small" @click="downloadFile(text)"
            >下载</a-button
          >
        </template>
      </BasicTable>
      <!-- 表单区域 -->
      <StPlanManModal @register="registerModal" @success="handleSuccess" :showSelectorBtn="true" @selector-click="handleSelectorClick" />
    </div>
  </div>
</template>

<script lang="ts" name="project-plan-stPlanManList" setup>
  import { reactive, ref, toRaw, unref,onMounted} from 'vue';
  import { batchDelete, deleteOne, getExportUrl, getImportUrl, handlePlan, listflow } from './StPlanMan.api';
  import { columns, searchFormSchema } from './StPlanMan.data';
  import StPlanManModal from './components/StPlanManModal.vue';
  import { JInput, JSearchSelect, JSelectDept } from '/@/components/Form';
  import { useModal } from '/@/components/Modal';
  import { BasicTable, TableAction } from '/@/components/Table';
  import { useListPage } from '/@/hooks/system/useListPage';
  import { downloadFile } from '/@/utils/common/renderUtils';
  import { message } from 'ant-design-vue';

  import { useUserStore } from '/@/store/modules/user';
   import { defHttp } from '/@/utils/http/axios';
 

  const showUpBtn = ref(false);
  const checkedKeys = ref<Array<string | number>>([]);
  //注册model
  const [registerModal, { openModal }] = useModal();
  const jSelectDeptVal = ref([]);
  
   


  //注册table数据
  const { prefixCls, tableContext, onExportXls, onImportXls } = useListPage({
    tableProps: {
      title: '计划编制',
      api: listflow,
      columns,
      canResize: false,
      useSearchForm: false,
      formConfig: {
        //labelWidth: 120,
        schemas: searchFormSchema,
        autoSubmitOnEnter: true,
        showAdvancedButton: true,
        fieldMapToNumber: [],
        fieldMapToTime: [],
      },
      actionColumn: {
        width: 240,
        fixed: 'right',
      },
      showTableSetting: false,
      beforeFetch(params) {
       
        params = Object.assign(params, { column: 'createdTime', order: 'desc' ,token: allReportData.value});
      },
    },
    exportConfig: {
      name: '计划编制',
      url: getExportUrl,
    },
    importConfig: {
      url: getImportUrl,
      success: handleSuccess,
    },
  });

  const [registerTable, { setProps, reload }, { rowSelection, selectedRowKeys }] = tableContext;
  const labelCol = reactive({
    xs: { span: 24 },
    sm: { span: 8 },
  });
  const wrapperCol = reactive({
    xs: { span: 24 },
    sm: { span: 16 },
  });
  const queryParam = reactive({});


  
  let url = window.location.href;
  console.log("----------- ",url); // 输出当前路由的完整路径
  let intNumber = url.indexOf("Token=");
  intNumber=intNumber+6;
  let cctoken=url.substring(intNumber);
  console.log("----------- cctoken",cctoken); // 输出当前路由的完整路径
  const allReportDataUrl = "/api/jflow/getUserTokey"
  const allReportData = ref('');
 
  const gettoken = async () => {
  allReportData.value  = await defHttp.get({url: allReportDataUrl, params:{Token:cctoken}});
  }

  onMounted(async () => {  
    await gettoken();  
    console.log("-----------St gettoken ",allReportData.value); 
  }); 


  

  

  function initParam() {
    const schemas = unref(searchFormSchema);
    schemas.forEach((item) => {
      queryParam[item.field] = '';
    });
    queryParam['checkClassFiy'] = null;
    queryParam['lableCodes'] = '';
    jSelectDeptVal.value = [];


     

  }
  initParam();
  function updateJSelectDept(val) {
    if (val.length > 0) {
      queryParam[searchFormSchema[2].field] = val[0];
    } else {
      jSelectDeptVal.value = [];
      queryParam[searchFormSchema[2].field] = '';
    }
  }
  function searchQuery() {
    setProps({ searchInfo: toRaw(queryParam) });
    reload();
  }
  function searchReset() {
    initParam();
    reload();
  }
  /**
   * 新增事件
   */
  function handleAdd() {
    openModal(true, {
      isUpdate: false,
      showFooter: true,
    });
  }
  /**
   * 编辑事件
   */
  function handleEdit(record: Recordable) {
    openModal(true, {
      record,
      isUpdate: true,
      showFooter: true,
    });
  }
  /**
   * 详情
   */
  function handleDetail(record: Recordable) {
    openModal(true, {
      record,
      isUpdate: true,
      showFooter: false,
    });
  }
  async function handleSubmit(record) {
    if (record.approveDepCode == '' || record.approveUser == '') {
      message.warning('请选择审核部门与审核人后进行提交');
    } else {
      record['planFlag'] = '1';
      await handlePlan(record, handleSuccess);
    }
  }
  /**
   * 删除事件
   */
  async function handleDelete(record) {
    await deleteOne({ id: record.id }, handleSuccess);
  }
  /**
   * 批量删除事件
   */
  async function batchHandleDelete() {
    await batchDelete({ ids: selectedRowKeys.value }, handleSuccess);
  }
  /**
   * 成功回调
   */
  function handleSuccess() {
    (selectedRowKeys.value = []) && reload();
  }
  /**
   * 操作栏
   */
  function getTableAction(record) {
    return [
      /**
      {
        label: '删除',
        color: 'error',
        disabled: record['planFlag'] != '0' && record['planFlag'] != '2' && record['planFlag'] != '9',
        popConfirm: {
          title: '是否确认删除该计划项',
          confirm: handleDelete.bind(null, record),
        },
      },
      {
        label: '修改',
        disabled: record['planFlag'] != '0' && record['planFlag'] != '2',
        onClick: handleEdit.bind(null, record),
      },
      {
        label: '提交',
        disabled: record['planFlag'] != '0' && record['planFlag'] != '2',
        popConfirm: {
          title: '是否确认提交',
          confirm: handleSubmit.bind(null, record),
        },
      },
      */
      {
        label: '详情',
        onClick: handleDetail.bind(null, record),
      },
    ];
  }
  /**
   * 下拉操作栏
   */
  function getDropDownAction(record) {
    return [];
  }
</script>

<style scoped></style>
